commit 58752dd237e95d06c080c7669f039a2c7cfac938
Author: Jonathan Wakely <jwakely@redhat.com>
Date:   Mon Oct 4 16:22:00 2021

    libstdc++: Support printing volatile pointers (P1147R1)
    
    To avoid needing to export a new symbol from the library (for now) the
    new member function uses __attribute__((always_inline)).
    
    libstdc++-v3/ChangeLog:
    
            * include/std/ostream (operator<<(const volatile void*)):
            Add new overload, as per P1147R1.
            * testsuite/27_io/basic_ostream/inserters_other/char/volatile_ptr.cc:
            New test.
    
    (cherry picked from commit 96955a82f0e1624a20ea2c9953d76a20ea433c24)

diff --git a/libstdc++-v3/include/std/ostream b/libstdc++-v3/include/std/ostream
index 981697324c9..722d4ff61b5 100644
--- a/libstdc++-v3/include/std/ostream
+++ b/libstdc++-v3/include/std/ostream
@@ -251,6 +251,13 @@ _GLIBCXX_BEGIN_NAMESPACE_VERSION
       { return *this << "nullptr"; }
 #endif
 
+#if __cplusplus > 202002L
+      __attribute__((__always_inline__))
+      __ostream_type&
+      operator<<(const volatile void* __p)
+      { return _M_insert(const_cast<const void*>(__p)); }
+#endif
+
       /**
        *  @brief  Extracting from another streambuf.
        *  @param  __sb  A pointer to a streambuf
diff --git a/libstdc++-v3/testsuite/27_io/basic_ostream/inserters_other/char/volatile_ptr.cc b/libstdc++-v3/testsuite/27_io/basic_ostream/inserters_other/char/volatile_ptr.cc
new file mode 100644
index 00000000000..1b1a9434a95
--- /dev/null
+++ b/libstdc++-v3/testsuite/27_io/basic_ostream/inserters_other/char/volatile_ptr.cc
@@ -0,0 +1,11 @@
+// { dg-options "-std=gnu++23 -fno-inline" }
+// { dg-do link { target c++23 } }
+
+#include <iostream>
+
+int main()
+{
+  int i = 0;
+  volatile void* p = &i;
+  std::cout << p << std::endl;
+}

